package com.fastbee.iot.timer;

import cn.hutool.core.date.DateTime;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.fastbee.deviceData.api.renke.constant.RenKeDeviceTypeConstant;
import com.fastbee.deviceData.api.renke.service.RenKeAuthorizationService;
import com.fastbee.deviceData.domain.DeviceRealtimedataMeteorology;
import com.fastbee.deviceData.domain.DeviceRealtimedataWorms;
import com.fastbee.deviceData.service.impl.DeviceRealtimeDataMeteorologyServiceImpl;
import com.fastbee.deviceData.service.impl.DeviceRealtimeDataWormsServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;
import java.util.concurrent.TimeUnit;

/**
 * @author mijiupro
 */
@Component("renkeDeviceDateTask")
public class DeviceDateTask {


    @Autowired
    private StringRedisTemplate stringRedisTemplate;
    @Autowired
    private DeviceRealtimeDataWormsServiceImpl deviceRealtimedataWormsServiceImpl;
    @Autowired
    private DeviceRealtimeDataMeteorologyServiceImpl deviceRealtimedataMeteorologyServiceImpl;

    @Autowired
    private RenKeAuthorizationService renKeAuthorizationService;

    @Autowired
    private ThreadPoolTaskExecutor threadPoolTaskExecutor;

    /**
     * 在执行定时任务中出现了异常会终止调度，所以需要捕获异常以便于下一轮
     * 执行，不会影响下一次执行
     */
    public void getRenkeDeviceRealtimeData() throws Exception{

        //获取设备实时数据
        //请求参数
        HttpResponse response = HttpRequest.get("http://api.farm.0531yun.cn/api/v2.0/entrance/device/getRealTimeData")
                .header("token", renKeAuthorizationService.getToken())
                .execute();
        String respBodyStr = response.body();
        if(StringUtils.isBlank(respBodyStr)) {
            throw new RuntimeException("获取设备实时数据失败!");
        }
        JSONObject respBody = JSONUtil.parseObj(respBodyStr);
        JSONArray realtimeList = JSONUtil.parseArray(respBody.get("data"));
        threadPoolTaskExecutor.execute( () -> {System.err.println("设备实时数据："+realtimeList);});

        //TODO 解析实时数据保存到数据库
//        for (Object jsonObject : realtimeList){
//            JSONObject josnConversion = (JSONObject) jsonObject;
//            if (RenKeDeviceTypeConstant.WORM.equals(josnConversion.get("deviceType"))){
//                JSONObject josnArray = JSONUtil.parseObj(josnConversion.get("data"));
//                DeviceRealtimedataWorms deviceRealtimedataWorms = JSONUtil.toBean(josnArray, DeviceRealtimedataWorms.class);
//                deviceRealtimedataWorms.setCreateTime(DateTime.now());
//                if(deviceRealtimedataWormsServiceImpl.insertDeviceRealtimedataWorms(deviceRealtimedataWorms)==1){
//                    System.out.println("插入成功");
//                };
//            }else if (RenKeDeviceTypeConstant.MET.equals(josnConversion.get("deviceType"))){
//                JSONArray josnArray = JSONUtil.parseArray(josnConversion.get("data"));
//                for (Object json : josnArray){
//                    DeviceRealtimedataMeteorology deviceRealtimedataMeteorology = JSONUtil.toBean((JSONObject) json, DeviceRealtimedataMeteorology.class);
//                    deviceRealtimedataMeteorology.setCreateTime(DateTime.now());
//                    if(deviceRealtimedataMeteorologyServiceImpl.insertDeviceRealtimedataMeteorology(deviceRealtimedataMeteorology)==1){
//                        System.out.println("插入成功");
//                    }
//                }
//
//            }
//        }
    }


}

